/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: Nov 12, 2002
 * Time: 9:44:39 PM
 */
package ru.ezhiki.automat.human.logic;

import ru.ezhiki.utils.Debug;
import ru.ezhiki.utils.Signaller;

import java.util.*;
import java.util.logging.Logger;

public class Actions extends Thread
{
    private String name = "No Name";
    private String authors = "Unknown";
    private String date = "Unknown";

    public HashMap positions = null;
    public Vector actions = null;

    private Figure figure = null;

    private Signaller signaller = Signaller.getSignaller();
    public static long waitingDelay = 1;

    private int y0 = 0;
    private int curAction = 0;
    private int curSubAction = 0;
    private Logger logger = null;

    public Actions(String name, String authors, String date)
    {
        this.name = name;
        this.authors = authors;
        this.date = date;

        actions = new Vector();
        positions = new HashMap();
    }

    public String getActionsName()
    {
        return name;
    }

    public String getAuthors()
    {
        return authors;
    }

    public String getDate()
    {
        return date;
    }

    public void addPosition(Position aPosition)
    {
        positions.put(aPosition.getName(), aPosition);
    }

    public void addAction(Action action)
    {
        actions.add(action);
    }

    public void setFigure(Figure figure)
    {
        this.figure = figure;
    }

    public void processActions()
    {
        curAction = 0;
        curSubAction = 0;
        y0 = 0;
        A2();
    }

    private void A2()
    {
        if (logger != null)
            logger.info(">>> A2 (   ( \"" + name +  "\"))");

        while (y0 != 3)
        {
            switch (y0)
            {
                case 0:
                    if (x2_0() > 0)      {z2_0();                   y0 = 1; }
                    else
                    if (x2_0() == 0)     {                          y0 = 3; }
                break;
                case 1:
                    if (x2_1() > 0)      {z2_1();                           }
                    else
                    if (x2_1() == 0)     {                          y0 = 2; }
                break;
                case 2:
                    if (x2_2() == true)  {z2_2();                           }
                    else
                    if (x2_2() == false) {z2_3();                   y0 = 0; }
                break;
            }
        }

        if (logger != null)
            logger.info("<<< A2 (   ( \"" + name +  "\"))");
    }

    private int x2_0()
    {
        return actions.size() - curAction;
    }

    private int x2_1()
    {
        String type = ((Action)actions.elementAt(curAction)).getType();
        if (type.equals("delay"))
            return 1 - curSubAction;
        else if (type.equals("position"))
        {
            return 1 - curSubAction;
        }
        else
            return 0;
    }

    private boolean x2_2()
    {
        synchronized (signaller)
        {
            return signaller.hasSignals();
        }
    }

    private void z2_0()
    {
        if (logger != null)
            logger.info("    A2->z2_0 (  : ( \"" + name +  "\"))");

        curSubAction = 0;
    }

    private void z2_1()
    {
        if (logger != null)
            logger.info("    A2->z2_1 ( : ( \"" + name +  "\"))");

        Action action = (Action)actions.elementAt(curAction);
        String type = ((Action)actions.elementAt(curAction)).getType();
        if (type.equals("delay"))
        {
            try
            {
                sleep(new Long(action.getValue()).longValue());
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
            catch (NumberFormatException e)
            {
                e.printStackTrace();
            }
        }
        else if (type.equals("position"))
        {
            Position newPos = (Position)positions.get(action.getValue());
            Set nameSet = newPos.getJointNames();

            synchronized (signaller)
            {
                signaller.clear();
            }

            for (Iterator iterator = nameSet.iterator(); iterator.hasNext();)
            {
                JointAction jAction = newPos.getJointAction((String)iterator.next());
                Joint joint = figure.getJointByName(jAction.getName());

                if (joint != null)
                {
                    joint.setSpeeds(jAction.getSpeedTurn(), jAction.getSpeedTranslate());
                    joint.setAnglesAndLocation(jAction.getAngles(), jAction.getLocation());
                    synchronized (signaller)
                    {
                        signaller.addSignal();
                    }
                }
                else
                {
                    if (Debug.isDebug())
                        System.out.println("Cant't find joint with name :'" + jAction.getName() + "'");
                }
            }
        }

        curSubAction++;
    }

    private void z2_2()
    {
        if (logger != null)
            logger.info("    A2->z2_2 (   ( \"" + name +  "\"))");

        synchronized (signaller)
        {
            if (Debug.isDebug())
                System.out.println("number of working joints: " + signaller.toString().length());

            try
            {
                yield();
                sleep(waitingDelay);
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        }
    }

    private void z2_3()
    {
        if (logger != null)
            logger.info("    A2->z2_3 (  ... ( \"" + name +  "\"))");
        curAction++;
    }

    public void setLogger(Logger logger)
    {
        this.logger = logger;
    }
}
