/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: Nov 12, 2002
 * Time: 9:57:09 PM
 */
package ru.ezhiki.automat.human.logic;

import javax.vecmath.Vector3d;

public class JointAction
{
    private String name = "";
    private String speedTurn = "15";
    private String speedTranslate = "5";
    private Vector3d loc = null;
    private Vector3d angles = null;

    public JointAction(String name, String speedTurn, String speedTranslate)
    {
        this.name = name;
        this.speedTurn = speedTurn;
        this.speedTranslate = speedTranslate;
        loc = null;
        angles = null;
    }

    public JointAction(String name)
    {
        this.name = name;
        loc = null;
        angles = null;
    }

    public String getName()
    {
        return name;
    }

    public String getSpeedTurn()
    {
        return speedTurn;
    }

    public String getSpeedTranslate()
    {
        return speedTranslate;
    }

    public Vector3d getLocation()
    {
        return loc;
    }

    public Vector3d getAngles()
    {
        return angles;
    }

    public void setLocation(double x, double y, double z)
    {
        if (loc == null)
            loc = new Vector3d(0, 0, 0);

        loc.x = x;
        loc.y = y;
        loc.z = z;
    }

    public void setAngles(double x, double y, double z)
    {
        if (angles == null)
            angles = new Vector3d(0, 0, 0);

        angles.x = x;
        angles.y = y;
        angles.z = z;
    }
}
